<?php
c_include('extApp');

class FacebookExtApp extends ExtApp {
	var $fcb_obj;
	
	function __construct($aplicacion){
		parent::__construct($aplicacion);
	}
	
	function includes(){
		c_include('extension','app','usuario');
		
		if (!class_exists('Facebook')){
			require(CONF_REALPATH_APP."apps/app_facebook/tools/facebook.php");
		}
	}
	
	function registerWidgets(){
		$widgets = array('facebook_box'=>array('name'=>__('Caja de fans de Facebook'), 'folder'=>CONF_REALPATH_APP . 'apps/app_facebook/tools/widgets/facebook_box/'));
		
		return $widgets;
	}
	
	function addScripts(){		
		if (!empty($this->parametros['appId']) && !$GLOBALS['apps_added_scripts'][$this->carpeta]){
			$script_fb = '
			window.fbAsyncInit = function() {
    FB.init({
      appId      : "'.$this->parametros['appId'].'",
      xfbml      : true,
      version    : "v2.2"
    });
  };

  (function(d, s, id){
     var js, fjs = d.getElementsByTagName(s)[0];
     if (d.getElementById(id)) {return;}
     js = d.createElement(s); js.id = id;
     js.src = "//connect.facebook.net/es_LA/sdk.js";
     fjs.parentNode.insertBefore(js, fjs);
   }(document, "script", "facebook-jssdk"));';
			$GLOBALS['AppDoc']->addScriptDeclaration($script_fb, 'text/javascript');
			
			$GLOBALS['apps_added_scripts'][$this->carpeta] = true;
		}
	}
	
	/* FUNCIONES DE USUARIOS */
	
	function authenticateApp($param='gestionar_usuarios', $redirect_uri, $scope='email,user_friends'){
		if (empty($param))
			$param = 'gestionar_usuarios';
		
		if (is_object($this->fcb_obj)) {
			$user_id = $this->fcb_obj->getUser();
			if (!empty($user_id)){
				return true;
			} else {
				$login_url = $this->fcb_obj->getLoginUrl(array(
					'scope' => $scope, 'display' => 'popup'
				)).'&output=embed';
				
				Helpers::redirect($login_url);
				exit;
			}
		} else {
			$appId = $this->parametros['appId'];
			$secret = $this->parametros['secret'];
			
			$activo = $this->activo == '1' ? true : false;
			
			if ($activo)
				$activo = $this->parametros[$param] == '1' ? true : false;
			
			if (empty($appId) || empty($secret) || !$activo){
				return __('No se puede usar la aplicación de Facebook');
			}
			
			# Creating the facebook object
			$facebook = new Facebook(array(
				'appId'  => $appId,
				'secret' => $secret,
				'cookie' => false
			));
			
			# Let's see if we have an active session
			$user_id = $facebook->getUser();
			
			if (!empty($user_id)){
				$this->fcb_obj = $facebook;
				Helpers::getSesion()->set('apps.'.$this->nombre.'.autorizado', true);
				return true;
			} else {
				$login_url = $facebook->getLoginUrl(array(
					'scope' => $scope, 'display' => 'popup'
				)).'&output=embed';
				
				Helpers::redirect($login_url);
				exit;
			}
			
		}
	}
	
	function unauthenticateApp(){
		if ($this->isAuthenticatedApp()){
			$this->authenticateApp();
			$this->fcb_obj->destroySession();
			Helpers::getSesion()->clear('apps.'.$this->nombre.'.autorizado');
			return true;
		} else {
			return false;
		}
	}
	
	function isAuthenticatedApp(){
		return Helpers::getSesion()->get('apps.'.$this->nombre.'.autorizado');
	}
	
	function usrLogin($scope="email,user_friends"){
		$auth_usr = $this->authenticateApp('gestionar_usuarios', '', $scope);

		if($auth_usr === true) {
			# Active session, let's try getting the user id (getUser()) and user info (api->('/me'))
			try{
				$permissions = $this->fcb_obj->api("/me/permissions");
				
				if (!is_array($permissions['data']) || sizeof($permissions['data']) == 0){
					Helpers::redirect( $this->fcb_obj->getLoginUrl(array("scope" => $scope, "display" => "popup")).'&output=embed' );
					exit;
				}
				
				$permiso_email_concedido = false;
				$permiso_basic_info_concedido = false;
				
				if (sizeof($permissions['data']) == 1){
					if ($permissions['data'][0]['email'] == '1')
						$permiso_email_concedido = true;
						
					if ($permissions['data'][0]['public_profile'] == '1')
						$permiso_basic_info_concedido = true;
				} else {
					foreach ($permissions['data'] as $perm){
						if ($perm['permission'] == 'email' && $perm['status'] == 'granted')
							$permiso_email_concedido = true;
							
						if ($perm['permission'] == 'public_profile' && $perm['status'] == 'granted')
							$permiso_basic_info_concedido = true;
					}
				}
				
				if( $permiso_basic_info_concedido && $permiso_email_concedido ) {
					// Permission is granted!
					// Do the related task
					$can_post = true;
				} else {
					// We don't have the permission
					// Alert the user or ask for the permission!
					Helpers::redirect( $this->fcb_obj->getLoginUrl(array("scope" => $scope, "display" => "popup")).'&output=embed' );
					exit;
				}
				
				$user = $this->fcb_obj->api('/me');
				
				$imagen_usuario = $this->fcb_obj->api('/me', array(
					'fields' => 'picture',
					'type' => 'large'
				));
				$imagen_usuario = $imagen_usuario["picture"]["data"]["url"];
			} catch (Exception $e){}
			
			if(!empty($user)){
				if($can_post){
					
					if (!empty($imagen_usuario)){
						$ext = explode('.',$imagen_usuario);
						$ext = $ext[count($ext)-1];
						$ext = substr($ext, 0, 3);
		
						if (empty($ext))
							$ext = 'jpg';
						$img_name = md5($imagen_usuario).'.'.$ext;
						if (!is_dir(CONF_REALPATH_APP.'uploads/imagenes/usuarios')){
							Helpers::ftpCrearCarpeta('uploads/imagenes/usuarios');
						}
						if (!is_file(CONF_REALPATH_APP.'uploads/imagenes/usuarios/'.$img_name)){
							$ch = curl_init($imagen_usuario);
							$fp = fopen(CONF_REALPATH_APP.'uploads/imagenes/usuarios/'.$img_name, "w");
							
							curl_setopt($ch, CURLOPT_FILE, $fp);
							curl_setopt($ch, CURLOPT_HEADER, 0);
							
							curl_exec($ch);
							curl_close($ch);
							fclose($fp);
							chmod(CONF_REALPATH_APP.'uploads/imagenes/usuarios/'.$img_name, 0777);
						}
						$imagen_usuario = 'uploads/imagenes/usuarios/'.$img_name;
					}
					# We have an active session, let's check if we have already registered the user
					$existe_user_fb = new Usuario();
					
					$existe_user_fb = $existe_user_fb->Listar('facebook_uid="'.$user['id'].'" AND estado=1 AND email="'.$user['email'].'"');
					
					if (is_array($existe_user_fb) && count($existe_user_fb) == 1){
						$existe_user_fb = $existe_user_fb[0];
						$id_usuario = $existe_user_fb->id;
						if (empty($existe_user_fb->imagen) && !empty($imagen_usuario)){
							$existe_user_fb->setimagen($imagen_usuario);
						}
						
						Helpers::getSesion()->set('usuario.ultimo_acceso', $existe_user_fb->fecha_ultimo_acceso);
						$existe_user_fb->setfecha_ultimo_acceso(strftime(SistemaIdioma::formatoFecha('sistema')));
						$existe_user_fb->setcontrasena('');
						$existe_user_fb->prepararModificar();
						$existe_user_fb->Modificar();
					} else {
						$usuario_mideas = new Usuario();
						$usuario_mideas = $usuario_mideas->Listar('estado=1 AND email="'.$user['email'].'"');
						if (is_array($usuario_mideas) && count($usuario_mideas) == 1){
							$usuario_mideas = $usuario_mideas[0];
							$usuario_mideas->setfacebook_uid($user['id']);
							if (empty($usuario_mideas->imagen) && !empty($imagen_usuario))
								$usuario_mideas->setimagen($imagen_usuario);
								
							Helpers::getSesion()->set('usuario.ultimo_acceso', $usuario_mideas->fecha_ultimo_acceso);
							$usuario_mideas->setfecha_ultimo_acceso(strftime(SistemaIdioma::formatoFecha('sistema')));
							$usuario_mideas->setcontrasena('');
							$usuario_mideas->prepararModificar();
							$usuario_mideas->Modificar();
							
							$id_usuario = $usuario_mideas->id;
						} else {
                         	$cat_default = $GLOBALS['opciones']['ext_usuarios']['general']['categoria_defecto'];
														
							$nombre_usr = $user['name'];
							$username_usr = 'usr'.$user['id'];
							
							$nuevo_usuario = new Usuario();
							$nuevo_usuario->setfacebook_uid($user['id']);
							$nuevo_usuario->setnombre($nombre_usr);
							$nuevo_usuario->setusername($username_usr);
							$nuevo_usuario->setemail($user['email']);
                            $nuevo_usuario->setcategorias(json_encode(array($cat_default)));
							if (!empty($imagen_usuario))
								$nuevo_usuario->setimagen($imagen_usuario);
							$nuevo_usuario->setestado(1);
							$nuevo_usuario->setnivel_acceso(1);
							Helpers::getSesion()->set('usuario.ultimo_acceso', strftime(SistemaIdioma::formatoFecha('sistema')));
							$nuevo_usuario->setfecha_ultimo_acceso(strftime(SistemaIdioma::formatoFecha('sistema')));
							
							$id_usuario = $nuevo_usuario->Guardar();

							//$id_usuario = mysqli_insert_id();
						}
					}

					$usuario_loged = new Usuario();
					$usuario_loged->setid($id_usuario);
					$usuario_loged = $usuario_loged->BuscarId();
					if (!$usuario_loged){
						return __("No se ha encontrado el usuario. Error crítico!");
					}
					
					if (!empty($user['email']))
						$AppUsuario = $user['email'];
					else
						$AppUsuario = $user['username'];
						
					Helpers::getSesion()->set('usuario.AppIdUsuario', $id_usuario);
					Helpers::getSesion()->set('usuario.AppUsuario', $AppUsuario);
					Helpers::getSesion()->set('usuario.nivel_acceso', $usuario_loged->nivel_acceso);
					Helpers::getSesion()->set('usuario.fb', true);
					
					if ($save_in_cookie)
						self::setLoginCookie($id_usuario);
					
					return true;
					
				} else {
					return __("Permisos requeridos!");
					
				}
				
			} else {
				# For testing purposes, if there was an error, let's kill the script
				return __("Se ha producido un error inesperado");
				
			}
		} else {
			return $auth_usr;
			
			
		}

		return false;
	}
	
	function usrLogout(){
		if ($this->usrIsLoged()){
			//$this->fcb_obj->destroySession();
			return true;
		} else {
			return false;
		}
	}
	
	function usrIsLoged(){
		return $this->isAuthenticatedApp();
	}
	
	/* FUNCIONES DE AMIGOS */
	
	function frdList(){
		$auth_usr = $this->authenticateApp('gestionar_amigos', '', "email,user_friends");
		
		if ($auth_usr === true){
			
			# Active session, let's try getting the user id (getUser()) and user info (api->('/me'))
			try{
				$uid = $this->fcb_obj->getUser();
		
				$permissions = $this->fcb_obj->api("/me/permissions");
				
				if (!is_array($permissions['data']) || sizeof($permissions['data']) == 0){
					Helpers::redirect( $this->fcb_obj->getLoginUrl(array("scope" => $scope, "display" => "popup")).'&output=embed' );
					exit;
				}
				
				$permiso_amigos_concedido = false;
				
				if (sizeof($permissions['data']) == 1){
					if ($permissions['data'][0]['user_friends'] == '1')
						$permiso_amigos_concedido = true;
				} else {
					foreach ($permissions['data'] as $perm){
						if ($perm['permission'] == 'user_friends' && $perm['status'] == 'granted')
							$permiso_amigos_concedido = true;
					}
				}
				
				if( $permiso_amigos_concedido ) {
					// Permission is granted!
					// Do the related task
					$can_post = true;
				} else {
					// We don't have the permission
					// Alert the user or ask for the permission!
					Helpers::redirect( $this->fcb_obj->getLoginUrl(array("scope" => "user_friends", "display" => "popup")) );
					exit;
				}
				
				$friends = $this->fcb_obj->api('/me/friends');
				
			} catch (Exception $e){}
			
			$amigos_en_mideas = array();
			
			if(is_array($friends["data"]) && sizeof($friends["data"]) > 0){
				
				foreach ($friends["data"] as $fr){
					# We have an active session, let's check if we have already registered the user
					$existe_user_fb = new Usuario();
					
					$existe_user_fb_c = $existe_user_fb->ListarCount('facebook_uid="'.$fr['id'].'" AND estado=1');
					
					if ($existe_user_fb_c == 1){
						$existe_user_fb = $existe_user_fb->Listar('facebook_uid="'.$fr['id'].'" AND estado=1');
						$amigos_en_mideas[] = $existe_user_fb[0]->id;
					}
				}
				
				if (sizeof($amigos_en_mideas) > 0){
					Helpers::getSesion()->set('usuario.facebook_friends', $amigos_en_mideas);
					return true;
				} else {
					App::setMsg(__("No hemos encontrado a ningún amigo de Facebook registrado en nuestra web"), 'error');
					if ($this->parametros['amigos_boton_accion'] == 'popup'){
						echo '<script>opener.location.reload(true);window.close();</script>';
					} else {
						$last_url = Helpers::getSesion()->get('lastUrl');
						Helpers::redirect($last_url);
					}
					exit;
				}
		
			} else {
				# For testing purposes, if there was an error, let's kill the script
				App::setMsg(__("No se ha podido recuperar ningún amigo desde Facebook"), 'error');
				if ($this->parametros['amigos_boton_accion'] == 'popup'){
					echo '<script>opener.location.reload(true);window.close();</script>';
				} else {
					$last_url = Helpers::getSesion()->get('lastUrl');
					Helpers::redirect($last_url);
				}
				exit;
			}

		} else {
			App::setMsg($auth_usr, 'error');
			if ($this->parametros['amigos_boton_accion'] == 'popup'){
				echo '<script>opener.location.reload(true);window.close();</script>';
			} else {
				$last_url = Helpers::getSesion()->get('lastUrl');
				Helpers::redirect($last_url);
			}
			exit;
		}
		
		return false;
		
	}
}